(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs/operators'), require('rxjs'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define('@amcdnl/ngx-echarts', ['exports', '@angular/core', 'rxjs/operators', 'rxjs', '@angular/common'], factory) :
	(factory((global.amcdnl = global.amcdnl || {}, global.amcdnl['ngx-echarts'] = {}),global.ng.core,global.Rx.Observable.prototype,global.rxjs,global.ng.common));
}(this, (function (exports,core,operators,rxjs,common) { 'use strict';

var EChartsComponent = /** @class */ (function () {
    function EChartsComponent(_elementRef, _ngZone) {
        this._elementRef = _elementRef;
        this._ngZone = _ngZone;
        this.chartClick = new core.EventEmitter();
        this.chartDblClick = new core.EventEmitter();
        this.chartMouseDown = new core.EventEmitter();
        this.chartMouseUp = new core.EventEmitter();
        this.chartMouseOver = new core.EventEmitter();
        this.chartMouseOut = new core.EventEmitter();
        this.chartGlobalOut = new core.EventEmitter();
        this.chartContextMenu = new core.EventEmitter();
        this.chartDataZoom = new core.EventEmitter();
        this._loaded = false;
        this._destroy$ = new rxjs.Subject();
    }
    EChartsComponent.prototype.ngOnInit = function () {
        var _this = this;
        this._ngZone.onStable
            .pipe(operators.take(1))
            .subscribe(function () { return _this._createChart(); });
        this._ngZone.runOutsideAngular(function () {
            rxjs.fromEvent(window, 'resize')
                .pipe(operators.distinctUntilChanged(), operators.debounceTime(10), operators.takeUntil(_this._destroy$)).subscribe(function () { return _this.resize(); });
        });
    };
    EChartsComponent.prototype.ngOnChanges = function (changes) {
        if (this._chart && this._loaded) {
            var result = {};
            for (var change in changes) {
                if (this[change]) {
                    result[change] = changes[change].currentValue;
                }
            }
            this.setOptions(result);
        }
    };
    EChartsComponent.prototype.ngOnDestroy = function () {
        if (this._chart) {
            this._chart.dispose();
            this._chart = null;
        }
        this._destroy$.next();
        this._destroy$.complete();
    };
    EChartsComponent.prototype.resize = function () {
        if (this._chart) {
            this._chart.resize();
        }
    };
    EChartsComponent.prototype.setOptions = function (changes) {
        this._chart.setOption(changes);
    };
    EChartsComponent.prototype._createChart = function () {
        var _this = this;
        this._ngZone.runOutsideAngular(function () {
            _this._chart = echarts.init(_this._elementRef.nativeElement, _this.theme);
            _this._chart.on('click', function (e) { return _this._ngZone.run(function () { return _this.chartClick.emit(e); }); });
            _this._chart.on('dblClick', function (e) { return _this._ngZone.run(function () { return _this.chartDblClick.emit(e); }); });
            _this._chart.on('mousedown', function (e) { return _this._ngZone.run(function () { return _this.chartMouseDown.emit(e); }); });
            _this._chart.on('mouseup', function (e) { return _this._ngZone.run(function () { return _this.chartMouseUp.emit(e); }); });
            _this._chart.on('mouseover', function (e) { return _this._ngZone.run(function () { return _this.chartMouseOver.emit(e); }); });
            _this._chart.on('mouseout', function (e) { return _this._ngZone.run(function () { return _this.chartMouseOut.emit(e); }); });
            _this._chart.on('globalout', function (e) { return _this._ngZone.run(function () { return _this.chartGlobalOut.emit(e); }); });
            _this._chart.on('contextmenu', function (e) { return _this._ngZone.run(function () { return _this.chartContextMenu.emit(e); }); });
            _this._chart.on('datazoom', function (e) { return _this._ngZone.run(function () { return _this.chartDataZoom.emit(e); }); });
            _this.setOptions({
                visualMap: _this.visualMap,
                title: _this.title,
                tooltip: _this.tooltip,
                legend: _this.legend,
                series: _this.series,
                xAxis: _this.xAxis,
                yAxis: _this.yAxis,
                animation: _this.animation
            });
            _this._loaded = true;
        });
    };
    return EChartsComponent;
}());
EChartsComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ngx-echart',
                template: "<ng-content></ng-content>",
                changeDetection: core.ChangeDetectionStrategy.OnPush,
                host: {
                    '[class.ngx-echart]': 'true'
                }
            },] },
];
EChartsComponent.ctorParameters = function () { return [
    { type: core.ElementRef },
    { type: core.NgZone }
]; };
EChartsComponent.propDecorators = {
    theme: [{ type: core.Input }],
    title: [{ type: core.Input }],
    tooltip: [{ type: core.Input }],
    legend: [{ type: core.Input }],
    series: [{ type: core.Input }],
    loading: [{ type: core.Input }],
    xAxis: [{ type: core.Input }],
    yAxis: [{ type: core.Input }],
    visualMap: [{ type: core.Input }],
    animation: [{ type: core.Input }],
    chartClick: [{ type: core.Output }],
    chartDblClick: [{ type: core.Output }],
    chartMouseDown: [{ type: core.Output }],
    chartMouseUp: [{ type: core.Output }],
    chartMouseOver: [{ type: core.Output }],
    chartMouseOut: [{ type: core.Output }],
    chartGlobalOut: [{ type: core.Output }],
    chartContextMenu: [{ type: core.Output }],
    chartDataZoom: [{ type: core.Output }]
};
var EChartsModule = /** @class */ (function () {
    function EChartsModule() {
    }
    return EChartsModule;
}());
EChartsModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [common.CommonModule],
                declarations: [EChartsComponent],
                exports: [EChartsComponent]
            },] },
];

exports.EChartsModule = EChartsModule;
exports.EChartsComponent = EChartsComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=amcdnl-ngx-echarts.umd.js.map
